{
Jogo Pouso Perfeito
Objetivo: pousar um avio em segurana no solo
Autor: Lucas Alexandre
Em 17/07/2018
}

program pouso_perfeito;
{$APPTYPE CONSOLE}
uses console, passapi, GameUI, SDL_Mixer, sound, sysUtils, tolk, windows;

var
altitude: integer=15000;
velocidade: integer=280;
tempo: integer=1;
ch: array[1..4] of integer; { Canais de alarmes }

procedure mensagem(msg: string);
begin
writeln(msg); fala(msg,false);
end;

function jogo: boolean;
var c: char;
i, j, k: integer;
s: string;
label impacto;
begin
jogo:=true;
sleep(1); inc(tempo);
if keypressed then
c:=readkey;
case upcase(c) of
#72: inc(velocidade);
#80: dec(velocidade);
'A': writeln(altitude,' metros');
'S': writeln(velocidade,' velocidade');
end;
if tempo=1000 then
begin
if velocidade>350 then
begin
if mix_Playing(ch[3])=0 then ch[3]:=play('alerta3.wav',-1);
end
else
Mix_HaltChannel(ch[3]);
if velocidade>400 then
begin
DiscardMusic;
WaitSound(play('explosao.wav',0));
halt(0);
end;
if (altitude<=500) and (velocidade>160) then
begin
if Mix_Playing(ch[1])=0 then ch[1]:=play('alerta1.wav',-1);
end
else Mix_HaltChannel(ch[1]);
if (altitude>1000) and (velocidade<=140) then
begin
if altitude>6000 then
begin
mensagem('O avio no suportou a descida brusca e se desintegrou');
goto impacto;
end;
altitude:=altitude-1000;
if mix_Playing(ch[2])=0 then ch[2]:=play('alerta2.wav',-1);
end
else
Mix_HaltChannel(ch[2]);
if (altitude<=1000) and (velocidade<=100) then
begin
altitude:=altitude-500;
if Mix_Playing(ch[4])=0 then ch[4]:=play('alerta5.wav',-1);
mensagem('Avio em mergulho');
end
else
Mix_HaltChannel(ch[4]);
randomize;
k:=random(50);
if (k=2) and (altitude<=1000) then
begin
play('alerta4.wav',0);
mensagem('Tesoura de vento, cuidado com a velocidade!');
velocidade:=velocidade-20;
end;
if altitude<=1100 then
begin
s:=intToStr(altitude);
j:=length(s);
s:=s[1];
for i:=2 to j do s:=s+'0';
mensagem(s);
end;
tempo:=1;
altitude:=altitude-(velocidade div 2); inc(velocidade);
end;
if (altitude<=0) and (velocidade<=100) then
begin
impacto:
DiscardMusic;
Mix_HaltChannel(-1);
WaitSound(play('impacto.wav',0));
mensagem('O avio mergulhou e colidiu no solo');
mensagem('Aperte Enter para sair');
readkey;
halt(0);
end;
if ((altitude<=0) and (velocidade>160)) then
begin
DiscardMusic;
Mix_HaltChannel(-1);
WaitSound(play('impacto.wav',0));
mensagem('Misso falhou');
mensagem('Aperte Enter para sair');
readkey;
halt(0);
end;
if (altitude<=0) and (velocidade>=140) and (velocidade<=160) then
begin
Mix_HaltChannel(-1);
play('pouso.wav',0);
DiscardMusic;
mensagem('Parabns pelo pouso perfeito');
mensagem('Aperte Enter para sair');
readln;
halt(0);
end;
end;

begin
IniciaSapi;
mensagem('Pouso perfeito');
clrscr;
setWindowTitle('Pouso Perfeito');
IniciaSapi;
OpenMusic('background.ogg');
MusicVolume(50);
PlayMusic(-1);
while jogo do;
end.
