program consoleapp;
uses tolk;
var name: pWchar_t;

begin
    name := nil;
    // Initialize Tolk
  Tolk_Load;
    writeln('Querying for the active screen reader driver...');
  name := Tolk_DetectScreenReader();
  if name <> '' then
    begin
    writeln('The active screen reader driver is: ');
    writeln(WideCharToString(name));
    end
  else
    writeln('None of the supported screen readers is running');

  if Tolk_HasSpeech then
    writeln('This screen reader driver supports speech');

  if Tolk_HasBraille then
    writeln('This screen reader driver supports braille');

  writeln('Let''s output some text...');
  // C does not have default parameter values (compile as C++)
  if (not Tolk_Output('Hello, World!', false)) then
    writeln('Failed to output text');

  writeln('Finalizing Tolk...');
  // Tolk will also try to uninitialize COM
  Tolk_Unload;

  writeln('Done!');
end.
